
USE SVH_REPORT_DB
GO

/*
|| Autor: Dani Bieto
|| Fecha: 2022.05.18
|| Proyecto: JUNO
|| Proceso: Actualizar la tabla MAESTRO_CARTERA, con los valores de FI PARTIDAS
||				Solo se actualizaran los campos que dependen de estos importes
*/


--=========================================================================================================================================
--														         UPDATE CIERRE CONTABLE - MAESTRO_CARTERA
--=========================================================================================================================================

/*
|| Modificaciones.
||		- El campo ADJ323 y USR060 se calculan de la misma manera
*/

/*
|| Modificaciones
|| Fecha: 2022.05.06
|| Motivo:
|| 	- Provisonalmente se ha creado variable de fecha de cierre contable. Lidia nos ha pedido que la fecha de cierre contable sea de marzo, y no la de abril.
*/

DECLARE @FECHA_CIERRE_CONTABLE VARCHAR(10);
DECLARE @ANYOMES VARCHAR(6);
DECLARE @PERIODO_ANT_ADJ INT, @PERIODO_ANT_ARR INT;


SET @ANYOMES = CONVERT(VARCHAR(6),DATEADD(dd,-(DAY(GETDATE())),GETDATE()),112);
SET @PERIODO_ANT_ADJ = (SELECT MAX(PERIODO) FROM [JUNO].[INF_ADJUDICADOS] WHERE PERIODO != @ANYOMES);
SET @PERIODO_ANT_ARR = (SELECT MAX(PERIODO) FROM [JUNO].[INF_ARRENDAMIENTO] WHERE PERIODO != @ANYOMES);

--=======================================================================
--							TEMPORALES
--=======================================================================

DROP TABLE IF EXISTS #TMP_SOCIEDADES

SELECT CAMPO, 
		 VALOR AS SOCIEDAD
  INTO #TMP_SOCIEDADES
  FROM [JUNO].[TMP_PARAMETRICA]
WHERE INFORME = 'SOCIEDAD'
  AND CONCEPTO = 'KUTXABANK. PERIMETRO INMOBILIARIA'
  AND FLAG = 1

--=========================================================================================================================================
--										Tabla Temporal con los datos del Histórico (Repositorio) Mes Anterior ADJUDICADOS
--=========================================================================================================================================

	DROP TABLE IF EXISTS #TMP_JUNO_INF_ADJUDICADOS_PERIODO_ANT
	SELECT TOP 1 WITH TIES
		  INF_ADJ.PERIODO
		, INF_ADJ.USR003 -- SOCIEDAD
		, INF_ADJ.USR004 -- CODIGO ACTIVO (UNIDAD_REGISTRAL)
		, INF_ADJ.CONS10 -- DOTACION RECUPERACION
		, INF_ADJ.ADJ149 -- COSTES DE MANTENIMIENTO: SEGURO
		, INF_ADJ.ADJ150 -- COSTES DE MANTENIMIENTO: GASTOS COMUNIDAD
		, INF_ADJ.ADJ247 -- COSTES DE MANTENIMIENTO: IMPUESTOS
		, INF_ADJ.BDE027 -- COSTES DE MANTENIMIENTO: GESTOR
		, INF_ADJ.ADJ327 -- COSTES DE MANTENIMIENTO: OTROS GASTOS
		, INF_ADJ.USR089 -- INGRESOS	
 		, INF_ADJ.USR077 -- ITP
		, INF_ADJ.USR078 -- AJD
		, INF_ADJ.USR079 -- Saneamiento adjudicación Comunidades
		, INF_ADJ.USR080 -- Saneamiento adjudicación IBI
		, INF_ADJ.USR099 -- Plusvalía por adquisición			
		, ROW_NUMBER() OVER(PARTITION BY INF_ADJ.USR003, INF_ADJ.USR004 ORDER BY INF_ADJ.ORIGEN DESC) RN_ADJUDICADOS
		INTO #TMP_JUNO_INF_ADJUDICADOS_PERIODO_ANT
	FROM [JUNO].[INF_ADJUDICADOS] INF_ADJ	
	WHERE INF_ADJ.IND_MIGRACION = 'X'
	  AND INF_ADJ.PERIODO = @PERIODO_ANT_ADJ  
	ORDER BY RN_ADJUDICADOS


--=========================================================================================================================================
--										Tabla Temporal con los datos del Histórico (Repositorio) Mes Anterior ARRENDAMIENTO
--=========================================================================================================================================

DROP TABLE IF EXISTS #TMP_INF_ARRENDAMIENTO_PERIODO_ANT

SELECT PERIODO 
	 , ADJ317 -- CODIGO ACTIVO
	 , ADJ365 -- ID ARRENDATARIO
	 , ADJ466 -- COSTES IMPUTABLES INQUILINOS
INTO #TMP_INF_ARRENDAMIENTO_PERIODO_ANT
  FROM [JUNO].[INF_ARRENDAMIENTO] ADJ
 WHERE PERIODO = @PERIODO_ANT_ARR
 
 --=========================================================================================================================================
--										Tabla Temporal con los datos de FI_PARTIDAS
--=========================================================================================================================================

DROP TABLE IF EXISTS #TMP_FI_PARTIDAS

SELECT PERIODO,
       SOCIEDAD, 
	   UNIDAD_REGISTRAL,
	   CONS10_DOTACION_RECUPERACION, -- CONS10
	   ADJ149_COSTES_MANTENIMIENTO_SEGURO,
	   ADJ150_COSTES_MANTENIMIENTO_COMUNIDAD,
	   ADJ247_COSTES_MANTENIMIENTO_IMPUESTOS,
	   BDE027_COSTES_MANTENIMIENTO_GESTOR,
	   ADJ327_COSTES_MANTENIMIENTO_OTROS,
	   USR089_INGRESOS_HASTA_VENTA,
	   ADJ178_FIANZA_RECIBIDA,
	   ADJ179_CANTIDADES_RECIBIDAS,
	   ADJ466_COSTES_IMPUTABLES_INQUILINOS,
	   ADJ180_ALQUILERES_VENCIDOS_PENDIENTES,
	   USR077_ITP,
	   USR078_AJD,
	   USR079_SANEAMIENTO_ADJUDICACION_COMUNIDADES,
	   USR080_SANEAMIENTO_ADJUDICACION_IBI,
	   USR099_PLUSVALIA_POR_ADJUDICACION
INTO #TMP_FI_PARTIDAS
  FROM [JUNO].MAESTRO_FI_PARTIDAS_UR
 WHERE PERIODO = @ANYOMES
 

--==========================================================================================================================================
--										UPDATES TABLA MAESTRO_CARTERA
--==========================================================================================================================================


UPDATE CARTERA
SET
CARTERA.ADJ149_COSTES_MANTENIMIENTO_SEGURO    =         ISNULL(ADJ_ANT.ADJ149,0) + ISNULL(FI_PARTIDAS.ADJ149_COSTES_MANTENIMIENTO_SEGURO,0),
CARTERA.ADJ150_COSTES_MANTENIMIENTO_COMUNIDAD =         ISNULL(ADJ_ANT.ADJ150,0) + ISNULL(FI_PARTIDAS.ADJ150_COSTES_MANTENIMIENTO_COMUNIDAD,0),
CARTERA.ADJ247_COSTES_MANTENIMIENTO_IMPUESTOS =         ISNULL(ADJ_ANT.ADJ247,0) + ISNULL(FI_PARTIDAS.ADJ247_COSTES_MANTENIMIENTO_IMPUESTOS,0),
CARTERA.CONS10_DOTACION_RECUPERACION          =         CASE WHEN CARTERA.SOCIEDAD = 280 THEN ISNULL(APORTACION_CONS10.CONS10_DOTACION_RECUPERACION,0) + 
                                                                                              ISNULL(ADJ_ANT.CONS10,0) + 
                                                                                              ISNULL(FI_PARTIDAS.CONS10_DOTACION_RECUPERACION,0)
                                                             ELSE ISNULL(ADJ_ANT.CONS10,0) + ISNULL(FI_PARTIDAS.CONS10_DOTACION_RECUPERACION,0)
                                                        END,
CARTERA.BDE027_COSTES_MANTENIMIENTO_GESTOR    =         ISNULL(ADJ_ANT.BDE027,0) + ISNULL(FI_PARTIDAS.BDE027_COSTES_MANTENIMIENTO_GESTOR,0),
CARTERA.ADJ327_COSTES_MANTENIMIENTO_OTROS     =         ISNULL(ADJ_ANT.ADJ327,0) + ISNULL(FI_PARTIDAS.ADJ327_COSTES_MANTENIMIENTO_OTROS,0),
CARTERA.USR089_INGRESOS_HASTA_VENTA			  =         ISNULL(ADJ_ANT.USR089,0) + ISNULL(FI_PARTIDAS.USR089_INGRESOS_HASTA_VENTA,0),
CARTERA.USR077_ITP                            =         ISNULL(ADJ_ANT.USR077,0) + ISNULL(FI_PARTIDAS.USR077_ITP,0),
CARTERA.USR078_AJD                            =         ISNULL(ADJ_ANT.USR078,0) + ISNULL(FI_PARTIDAS.USR078_AJD,0),
CARTERA.USR079_SANEAMIENTO_ADJUDICACION_COMUNIDADES =   ISNULL(ADJ_ANT.USR079,0) + ISNULL(FI_PARTIDAS.USR079_SANEAMIENTO_ADJUDICACION_COMUNIDADES,0),
CARTERA.USR080_SANEAMIENTO_ADJUDICACION_IBI   =         ISNULL(ADJ_ANT.USR080,0) + ISNULL(FI_PARTIDAS.USR080_SANEAMIENTO_ADJUDICACION_IBI,0),
CARTERA.USR099_PLUSVALIA_POR_ADJUDICACION     =         ISNULL(ADJ_ANT.USR099,0) + ISNULL(FI_PARTIDAS.USR099_PLUSVALIA_POR_ADJUDICACION,0)
FROM [JUNO].[MAESTRO_CARTERA] CARTERA
INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
INNER JOIN #TMP_SOCIEDADES SOC 
  ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
LEFT JOIN #TMP_JUNO_INF_ADJUDICADOS_PERIODO_ANT ADJ_ANT 
  ON CARTERA.USR003_NUM_SOCIEDAD  = ADJ_ANT.USR003 
 AND CARTERA.USR004_CODIGO_ACTIVO = ADJ_ANT.USR004
LEFT JOIN #TMP_FI_PARTIDAS FI_PARTIDAS
  ON CARTERA.SOCIEDAD         = FI_PARTIDAS.SOCIEDAD
 AND CARTERA.UNIDAD_REGISTRAL = FI_PARTIDAS.UNIDAD_REGISTRAL
LEFT JOIN [JUNO].[TMP_APORTACION_CONS10_JUNIO] APORTACION_CONS10
  ON CARTERA.SOCIEDAD          = APORTACION_CONS10.SOCIEDAD
 AND CARTERA.UNIDAD_REGISTRAL  = APORTACION_CONS10.UNIDAD_REGISTRAL
WHERE CARTERA.PERIODO = @ANYOMES
AND UR.IND_MIGRACION = 'X'


--==========================================================================================================================================
--										UPDATES TABLA MAESTRO_ARRENDAMIENTO
--==========================================================================================================================================

UPDATE ARRENDAMIENTO
SET
ARRENDAMIENTO.ADJ178_FIANZA_RECIBIDA =			      ISNULL(FI_PARTIDAS.ADJ178_FIANZA_RECIBIDA,0),
ARRENDAMIENTO.ADJ180_ALQUILERES_VENCIDOS_PENDIENTES = ISNULL(FI_PARTIDAS.ADJ180_ALQUILERES_VENCIDOS_PENDIENTES,0),
ARRENDAMIENTO.ADJ466_COSTES_IMPUTABLES_INQUILINOS   = ISNULL(ARR_ANT.ADJ466,0) + ISNULL(FI_PARTIDAS.ADJ466_COSTES_IMPUTABLES_INQUILINOS,0)
FROM [JUNO].MAESTRO_UA_CONTRATOS ARRENDAMIENTO
INNER JOIN #TMP_SOCIEDADES SOC ON ARRENDAMIENTO.SOCIEDAD = SOC.SOCIEDAD
LEFT JOIN #TMP_INF_ARRENDAMIENTO_PERIODO_ANT ARR_ANT 
  ON ARRENDAMIENTO.ADJ317_CODIGO_ACTIVO   = ARR_ANT.ADJ317 
 AND ARRENDAMIENTO.ADJ365_ID_ARRENDATARIO = ARR_ANT.ADJ365
LEFT JOIN #TMP_FI_PARTIDAS FI_PARTIDAS
  ON ARRENDAMIENTO.SOCIEDAD         = FI_PARTIDAS.SOCIEDAD
 AND ARRENDAMIENTO.UNIDAD_REGISTRAL = FI_PARTIDAS.UNIDAD_REGISTRAL
WHERE ARRENDAMIENTO.PERIODO = @ANYOMES

